YAML::ENGINE.yamler = "syck"

module TicketflyApi
  class Base
    include HTTParty
   
    include TicketflyApi::Events
   
    default_params :output => 'json'
    format :json
    base_uri 'https://api-stage.ticketfly.com/v2/purchase'

    attr_reader :errors

    def initialize
      @errors = []
    end

    def call(command, options)
      begin
        result = self.class.get("/#{command}", :query => options)
      rescue HTTParty::UnsupportedFormat, HTTParty::UnsupportedURIScheme, HTTParty::ResponseError, HTTParty::RedirectionTooDeep
        raise NetworkError.new
      end

      if result && result.parsed_response == "<html><body><h1>500 Internal Server Error</h1></body></html>"
        @errors << "Ticketfly returned a 500 error"
        raise CommandError.new 
      end

      @errors << result["error"] if result && result["error"]
      raise InvalidResponseError.new if result.nil? || !result["error"].blank?
      result
    end
  end
end